' QASM Semi-Assembler 1 
' by: John Anderson 
'
' Basically what this program does is converts
' an assembly language program into a machine
' language string which can be used in the
' CALL ABSOLUTE statement.  The way this program
' is designed, you will have to append the direct
' value operands at the end of any assembly -
' machine operation manually.  That shouldn't be
' hard because the ## pound signs take the place
' of the numbers and the assembly statement is
' remarked automatically right next to the machine
' string equivalent. This program uses an approximately
' 800000 byte long text reference chart for conversions.
' I basically just copied them all using DOS DEBUG. (don't ask
' how :o). (Actually, if you look at the chart there
' definite pattern so pasting was pretty convienent)
' I'm really just beginning on assembly and made this
' program to help me out a little bit.
'
' You may have to readjust this program
' according to where you put the files.
'
'

DECLARE SUB CmdInit ()
DECLARE SUB FileInput ()
DECLARE SUB Loadprefs ()
DECLARE SUB LoadRef (file$)
DECLARE SUB RegInit ()
DECLARE FUNCTION ASMSM$ (s$)
DECLARE FUNCTION REGSTR% (P%, s$)


start:

ON ERROR GOTO errorfix

'GOTO skip

'TRON

DIM SHARED ofile(1 TO 2) AS STRING * 100
DIM SHARED cmd(1 TO 119) AS STRING
DIM SHARED L%(1 TO 2)
DIM SHARED mnpc%(1 TO 2)
DIM SHARED mxpc%(1 TO 2)
DIM SHARED reg$(1 TO 16)
DIM SHARED opendestfor$

CmdInit
RegInit
Loadprefs
FileInput
LoadRef "C:\abc2\mlr\mlr.txt"
END

errorfix:
  COLOR , 0
  CLS
  errn% = ERR
  erln% = ERL
  PRINT "ERROR:"; errn%; "    LINE:"; erln%
  PRINT
  PRINT "Press any key to continue: "
  DO UNTIL i$ <> "": i$ = INKEY$: LOOP
RESUME cleargotostart

cleargotostart:
  CLS : COLOR , 0: GOTO start

FUNCTION ASMSM$ (s$)
  s$ = UCASE$(s$)
  asmstr$ = ""
  FOR cmdn% = 1 TO 116
    lcmd$ = (" " + cmd$(cmdn%) + " ")
    isn% = INSTR(1, s$, lcmd$)
    SELECT CASE isn%
      CASE 0
      CASE ELSE
        asmstr$ = asmstr$ + (MID$(s$, isn%, (LEN(lcmd$))))
        EXIT FOR
    END SELECT
  NEXT cmdn%
  IF LTRIM$(RTRIM$(asmstr$)) = "" THEN ASMSM$ = asmstr$: EXIT FUNCTION
  ln% = LEN(lcmd$)
  IF ln% >= LEN(s$) THEN ASMSM$ = asmstr$: GOTO endf
  DO
    SELECT CASE MID$(s$, ln%, 1)
      CASE " "
        ln% = ln% + 1
      CASE IS <> " "
        asmstr2$ = MID$(s$, ln%, (LEN(s$) - ln%))
        EXIT DO
    END SELECT
  LOOP
  places$ = ""
GOTO skipplaces
  FOR pstn% = 1 TO (LEN(asmstr2$))
    pan$ = LTRIM$(RTRIM$(STR$(pstn%)))
    SELECT CASE MID$(asmstr2$, ln%, 1)
      CASE ","
        places$ = places$ + "," + HEX$(LEN(pan$)) + pan$
      CASE "+"
        places$ = places$ + "+" + HEX$(LEN(pan$)) + pan$
      CASE "["
        places$ = places$ + "[" + HEX$(LEN(pan$)) + pan$
      CASE "]"
        places$ = places$ + "[" + HEX$(LEN(pan$)) + pan$
      CASE "0" TO "9", "F"
        places$ = places$ + "#" + HEX$(LEN(pan$)) + pan$
      CASE "A" TO "E"
        SELECT CASE pstn%
          CASE LEN(asmstr2$)
            places$ = places$ + HEX$(LEN(par$))
          CASE IS < LEN(asmstr2$)
            mdp2$ = MID$(asmstr2$, (pstn% + 1), 1)
            SELECT CASE mdp2$
              CASE "X", "L", "H", "P", "I"
                places$ = places$ + (MID$(asmstr$, pstn%, 1)) + HEX$(LEN(pan$)) + pan$
              CASE ELSE
                places$ = places$ + "#" + HEX$(LEN(pan$)) + pan$
            END SELECT
        END SELECT
      CASE " "
        places$ = places$ + " " + HEX$(LEN(pan$)) + pan$
      CASE "X", "L", "H", "P", "I"
        places$ = places$ + (HEX$(LEN(pan$))) + pan$
    END SELECT
  NEXT pstn%
skipplaces:
  p2% = 1
  L3% = LEN(asmstr2$)
  asmstr3$ = ""
  asmstr4$ = ""
  asmstr5$ = ""
  asmstr6$ = ""
  asmstr7$ = ""
  FOR p2% = 1 TO L3%
    sp1$ = MID$(asmstr2$, p2%, 1)
    SELECT CASE sp1$
      CASE ","
        asmstr4$ = asmstr4$ + "," + " "
      CASE "+"
        asmstr4$ = asmstr4$ + " " + "+" + " "
      CASE "[", "]", "A" TO "F", "H", "I", "L", "P", "S", "X"
        asmstr4$ = asmstr4$ + sp1$
      CASE "0" TO "9", "F"
        asmstr4$ = asmstr4$ + "#"
      CASE "A" TO "E"
        SELECT CASE p2%
          CASE L3%
            asmstr4$ = asmstr4$ + "#"
          CASE IS < L3%
            SELECT CASE MID$(asmstr2$, (p2% + 1), 1)
              CASE "X", "L", "H", "P", "I"
                asmstr4$ = asmstr4$ + sp1$
              CASE ELSE
                asmstr4$ = asmstr4$ + "#"
            END SELECT
        END SELECT
    END SELECT
  NEXT p2%
  asmstr7$ = asmstr$ + asmstr4$
  
ASMSM$ = asmstr7$

endf:

END FUNCTION

SUB CmdInit

  cmd$(1) = "AAA"        'ASCII adjust for addition
  cmd$(2) = "AAD"        'ASCII adjust for division
  cmd$(3) = "AAM"        'ASCII adjust for multiplication
  cmd$(4) = "AAS"        'ASCII adjust for subtraction
  cmd$(5) = "ADC"        'Add with carry
  cmd$(6) = "ADD"        'Add
  cmd$(7) = "AND"        'And
  cmd$(8) = "CALL"       'Call (Subroutine)
  cmd$(9) = "CBW"        'Convert byte to word
  cmd$(10) = "CLC"       'Clear carry flag
  cmd$(11) = "CLD"       'Clear direction flag
  cmd$(12) = "CLT"       'Clear interrupt flag
  cmd$(13) = "CMC"       'Complement carry flag
  cmd$(14) = "CMP"       'Compare
  cmd$(15) = "CMPS"      'Compare byte or word (of a string)
  cmd$(16) = "CMPSB"     'Compare byte (string)
  cmd$(17) = "CMPSW"     'Compare word (string)
  cmd$(18) = "CWD"       'Convert word to double word
  cmd$(19) = "DAA"       'Decimal adjust for addition
  cmd$(20) = "DAS"       'Decimal adjust for subtraction
  cmd$(21) = "DEC"       'Decrement
  cmd$(22) = "DIV"       'Divide
  cmd$(23) = "ESC"       'Escape
  cmd$(24) = "HLT"       'Halt
  cmd$(25) = "IDIV"      'Integer Divide
  cmd$(26) = "IMUL"      'Integer Multiply
  cmd$(27) = "IN"        'Input byte or word (to part)
  cmd$(28) = "INC"       'Increment
  cmd$(29) = "INT"       'Interrupt
  cmd$(30) = "INTO"      'Interrupt on overflow
  cmd$(31) = "IRET"      'Interrupt return
  cmd$(32) = "JA"        'Jump on above
  cmd$(33) = "JAE"       'Jump on above or equal
  cmd$(34) = "JB"        'Jump on below
  cmd$(35) = "JBE"       'Jump on below or equal
  cmd$(36) = "JC"        'Jump on carry
  cmd$(37) = "JCXZ"      'Jump on CX zero
  cmd$(38) = "JE"        'Jump on equal
  cmd$(39) = "JG"        'Jump on greater
  cmd$(40) = "JGE"       'Jump on greater or equal
  cmd$(41) = "JL"        'Jump on less than
  cmd$(42) = "JLE"       'Jump on less than or equal to
  cmd$(43) = "JMP"       'Jump
  cmd$(44) = "JNA"       'Jump on not above
  cmd$(45) = "JNAE"      'Jump on not above or equal
  cmd$(46) = "JNB"       'Jump on not below
  cmd$(47) = "JNBE"      'Jump on not below or equal
  cmd$(48) = "JNC"       'Jump on no carry
  cmd$(49) = "JNE"       'Jump on not equal
  cmd$(50) = "JNG"       'Jump on not greater
  cmd$(51) = "JNGE"      'Jump on not greater or equal
  cmd$(52) = "JNL"       'Jump on not less than
  cmd$(53) = "JNLE"      'Jump on not less than or equal to
  cmd$(54) = "JNO"       'Jump on not overflow
  cmd$(55) = "JNP"       'Jump on not parity
  cmd$(56) = "JNS"       'Jump on not sign
  cmd$(57) = "JNZ"       'Jump on not zero
  cmd$(58) = "JO"        'Jump on overflow
  cmd$(59) = "JP"        'Jump on parity
  cmd$(60) = "JPE"       'Jump on parity even
  cmd$(61) = "JPO"       'Jump on parity odd
  cmd$(62) = "JS"        'Jump on sign
  cmd$(63) = "JZ"        'Jump on zero
  cmd$(64) = "LAHF"      'Load AH with flags
  cmd$(65) = "LDS"       'Load pointer ino DS
  cmd$(66) = "LEA"       'Load effective address
  cmd$(67) = "LES"       'Load pointer into ES
  cmd$(68) = "LOCK"      'Lock bus
  cmd$(69) = "LODS"      'Load byte or word (of a string)
  cmd$(70) = "LODSB"     'Load byte (of a string)
  cmd$(71) = "LODSW"     'Load word (string)
  cmd$(72) = "LOOP"      'Loop
  cmd$(73) = "LOOPE"     'Loop while the result is equal
  cmd$(74) = "LOOPNE"    'Loop while the result is not equal
  cmd$(75) = "LOOPNZ"    'Loop while not zero
  cmd$(76) = "LOOPZ"     'Loop while zero
  cmd$(77) = "MOV"       'Move
  cmd$(78) = "MOVS"      'Move byte or word (of a string)
  cmd$(79) = "MOVBS"     'Move byte (string)
  cmd$(80) = "MOVSW"     'Move word (string)
  cmd$(81) = "MUL"       'Multiply
  cmd$(82) = "NEG"       'Negate
  cmd$(83) = "NOP"       'No operation
  cmd$(84) = "NOT"       'Not
  cmd$(85) = "OR"        'Or
  cmd$(86) = "OUT"       'Output byte or word
  cmd$(87) = "POP"       'Pop (Off of the stack, to a register or address)
  cmd$(88) = "POPF"      'Pop flags
  cmd$(89) = "PUSH"      'Push (onto the stack)
  cmd$(90) = "RCL"       'Rotate through carry left
  cmd$(91) = "RCR"       'Rotate through carry right
  cmd$(92) = "REP"       'Repeat
  cmd$(93) = "RET"       'Return
  cmd$(94) = "RETF"      'Return far
  cmd$(95) = "ROL"       'Rotate left
  cmd$(96) = "ROR"       'Rotate right
  cmd$(97) = "SAHF"      'Store AH into flags
  cmd$(98) = "SAL"       'Shift arithmetic left
  cmd$(99) = "SAR"       'Shift arithmetic right
  cmd$(100) = "SBB"       'Subtract with borrow
  cmd$(101) = "SCAS"     'Scan byte or word (of a string)
  cmd$(102) = "SCASB"    'Scan byte (string)
  cmd$(103) = "SCASW"    'Scan word (string)
  cmd$(104) = "SHL"      'Shift left
  cmd$(105) = "SHR"      'Shift right
  cmd$(106) = "STC"      'Set carry flag
  cmd$(107) = "STD"      'Set direction flag
  cmd$(108) = "STI"      'Set interrupt flag
  cmd$(109) = "STOS"     'Store byte or word (of a string)
  cmd$(110) = "STOSB"    'Store byte (string)
  cmd$(111) = "STOSW"    'Store word (string)
  cmd$(112) = "SUB"      'Subtract
  cmd$(113) = "TEST"     'Test
  cmd$(114) = "XCHG"     'Exchange
  cmd$(115) = "XLAT"     'Translate
  cmd$(116) = "XOR"      'Exclusive OR
  

END SUB

SUB FileInput
CLS
SCREEN 0: WIDTH 80, 50
GOSUB InitVars: GOSUB Initlocvars: GOSUB colorchange
LOCATE 1, 1: PRINT "<<<< QASM version 1 by John Anderson >>>>"
LOCATE 3, 1: PRINT sourceasm$
LOCATE 4, 1: PRINT desbas$
LOCATE 3, (LEN(sourceasm$) + 1): PRINT MID$(ofile$(1), spp%, 40)
LOCATE 4, (LEN(desbas$) + 1): PRINT MID$(ofile$(2), spp%, 40)
COLOR , 5: LOCATE r%, c% + (cpc% - 1): PRINT MID$(ofile$(f%), P%, 1)
COLOR , 0
DO
  DO
    SELECT CASE lc%
      CASE 10000
        SLEEP
        lc% = 0
    END SELECT
    i$ = INKEY$
    IF i$ <> "" THEN
      lc% = 0
      LOCATE r%, c%: PRINT MID$(ofile$(f%), spp%, 40)
      EXIT DO
    ELSE lc% = lc% + 1
    END IF
  LOOP
  SELECT CASE i$
    CASE up$
      LOCATE r%, c%: PRINT MID$(ofile$(f%), spp%, 40)
      SELECT CASE r%
        CASE 3
          cpc% = 1
          P% = 1
          spp% = 1
          r% = 4
          f% = 2
          c% = L%(f%)
        CASE 4
          cpc% = 1
          P% = 1
          spp% = 1
          r% = 3
          f% = 1
          c% = L%(f%)
      END SELECT
      LOCATE r%, c%: PRINT MID$(ofile$(f%), spp%, 40)
      COLOR , 5: LOCATE r%, c% + (cpc% - 1): PRINT MID$(ofile$(f%), P%, 1)
      COLOR , 0
    CASE down$
      LOCATE r%, c%: PRINT MID$(ofile$(f%), spp%, 40)
      SELECT CASE r%
        CASE 3
          cpc% = 1
          P% = 1
          spp% = 1
          r% = 4
          f% = 2
          c% = L%(f%)
        CASE 4
          cpc% = 1
          P% = 1
          spp% = 1
          r% = 3
          f% = 1
          c% = L%(f%)
      END SELECT
      LOCATE r%, c%: PRINT MID$(ofile$(f%), spp%, 40)
      COLOR , 5: LOCATE r%, c% + (cpc% - 1): PRINT MID$(ofile$(f%), P%, 1)
      COLOR , 0
    CASE lft$
      COLOR , 0: LOCATE r%, c% + (cpc% - 1): PRINT MID$(ofile$(f%), P%, 1)
      SELECT CASE cpc%
        CASE 2 TO 40
          cpc% = cpc% - 1
          P% = P% - 1
        CASE 1
          SELECT CASE P%
            CASE 2 TO 100
              P% = P% - 1
              spp% = spp% - 1
          END SELECT
      END SELECT
      COLOR , 5: LOCATE r%, c% + (cpc% - 1): PRINT MID$(ofile$(f%), P%, 1)
      COLOR , 0
    CASE rght$
      COLOR , 0: LOCATE r%, c% + (cpc% - 1): PRINT MID$(ofile$(f%), P%, 1)
      SELECT CASE cpc%
        CASE 1 TO 39
          cpc% = cpc% + 1
          P% = P% + 1
        CASE 40
          SELECT CASE P%
            CASE 1 TO 99
              P% = P% + 1
              spp% = spp% + 1
          END SELECT
      END SELECT
      COLOR , 5: LOCATE r%, c% + (cpc% - 1): PRINT MID$(ofile$(f%), P%, 1)
      COLOR , 0
    CASE " " TO "~"
      COLOR , 0: LOCATE r%, c% + (cpc% - 1): PRINT MID$(ofile$(f%), P%, 1)
      SELECT CASE ovr$
        CASE "OFF"
          FOR place% = 100 TO (P% + 1) STEP -1
            MID$(ofile$(f%), place%, 1) = MID$(ofile$(f%), (place% - 1), 1)
          NEXT place%
          MID$(ofile$(f%), P%, 1) = i$
        CASE "ON"
          MID$(ofile$(f%), P%, 1) = i$
      END SELECT
      SELECT CASE cpc%
        CASE 1 TO 39
          cpc% = cpc% + 1
            P% = P% + 1
          CASE 40
            SELECT CASE P%
              CASE 1 TO 99
                P% = P% + 1
                spp% = spp% + 1
            END SELECT
      END SELECT
      LOCATE r%, c%: PRINT MID$(ofile$(f%), spp%, 40)
      COLOR , 5: LOCATE r%, c% + (cpc% - 1): PRINT MID$(ofile$(f%), P%, 1)
      COLOR , 0
    CASE insert$
      SELECT CASE ovr$
        CASE "ON"
          ovr$ = "OFF"
          LOCATE 6, 1: PRINT "   "
        CASE "OFF"
        ovr$ = "ON"
          LOCATE 6, 1: PRINT "OVR"
      END SELECT
    CASE delete$
      COLOR , 0: LOCATE r%, c% + (cpc% - 1): PRINT MID$(ofile$(f%), P%, 1)
      SELECT CASE P%
        CASE 1
          ofile$(f%) = RIGHT$(ofile$(f%), 99) + " "
        CASE 2 TO 100
          FOR place% = P% TO 99 STEP 1
            MID$(ofile$(f%), place%, 1) = MID$(ofile$(f%), (place% + 1), 1)
          NEXT place%
          MID$(ofile$(f%), 100, 1) = " "
      END SELECT
      LOCATE r%, c%: PRINT MID$(ofile$(f%), spp%, 40)
      COLOR , 5: LOCATE r%, c% + (cpc% - 1): PRINT MID$(ofile$(f%), P%, 1)
      COLOR , 0
    CASE home$
      COLOR , 0: LOCATE r%, c% + (cpc% - 1): PRINT MID$(ofile$(f%), P%, 1)
      SELECT CASE ofile$(f%)
        CASE SPACE$(100)
          homep% = 1
        CASE ELSE
          homep% = (((LEN(ofile$(f%))) - (LEN(LTRIM$(ofile$(f%))))) + 1)
      END SELECT
      SELECT CASE homep%
        CASE spp% TO (spp% + 39)
          cpc% = (homep% - spp%) + 1
          P% = homep%
        CASE ELSE
          IF homep% > 61 THEN
            spp% = 61
            cpc% = (homep% - spp%) + 1
            P% = homep%
          ELSE
            spp% = homep%
            P% = homep%
            cpc% = 1
          END IF
      END SELECT
      LOCATE r%, c%: PRINT MID$(ofile$(f%), spp%, 40)
      COLOR , 5: LOCATE r%, c% + (cpc% - 1): PRINT MID$(ofile$(f%), P%, 1)
      COLOR , 0
    CASE endk$
      COLOR , 0: LOCATE r%, c% + (cpc% - 1): PRINT MID$(ofile$(f%), P%, 1)
      SELECT CASE ofile$(f%)
        CASE SPACE$(100)
          endp% = 1
        CASE ELSE
          endp% = (LEN(RTRIM$(ofile$(f%)))) + 1
          IF endp% > 100 THEN endp% = 100
      END SELECT
      SELECT CASE endp%
        CASE 100
          spp% = 61
          P% = endp%
          cpc% = 40
        CASE spp% TO (spp% + 38)
          cpc% = (endp% - spp%) + 1
          P% = endp%
        CASE ELSE
          IF homep% < 40 THEN
            spp% = 1
            cpc% = endp%
            P% = endp%
          ELSE
            spp% = (endp% - 39)
            P% = endp%
            cpc% = 40
          END IF
      END SELECT
      LOCATE r%, c%: PRINT MID$(ofile$(f%), spp%, 40)
      COLOR , 5: LOCATE r%, (c% + (cpc% - 1)): PRINT MID$(ofile$(f%), P%, 1)
      COLOR , 0
    CASE esc$
      END
    CASE ent$
      IF (ofile$(1) = SPACE$(100)) OR (ofile$(2) = SPACE$(100)) THEN END
      CLS
      PRINT #1, LTRIM$(RTRIM$(ofile$(1)))
      PRINT #1, LTRIM$(RTRIM$(ofile$(2)))
      CLOSE #1
      FILES ofile$(2)
      LOCATE 10, 1: PRINT "Do you wish to overwrite or append to the destination? (O/A)"
      DO
        i2$ = INKEY$
        SELECT CASE i2$
          CASE "A", "a"
            opendestfor$ = "APPEND"
            EXIT DO
          CASE "O", "o"
            opendestfor$ = "OUTPUT"
            EXIT DO
        END SELECT
      LOOP
      CLS
      EXIT DO
    CASE bksp$
      COLOR , 0: LOCATE r%, c% + (cpc% - 1): PRINT MID$(ofile$(f%), P%, 1)
      SELECT CASE P%
        CASE 2 TO 100
          FOR place% = (P% - 1) TO 99 STEP 1
            MID$(ofile$(f%), place%, 1) = MID$(ofile$(f%), (place% + 1), 1)
          NEXT place%
          MID$(ofile$(f%), 100, 1) = " "
      END SELECT
      SELECT CASE cpc%
        CASE 2 TO 40
          cpc% = cpc% - 1
          P% = P% - 1
        CASE 1
          SELECT CASE P%
            CASE 2 TO 100
              P% = P% - 1
              spp% = spp% - 1
          END SELECT
      END SELECT
      LOCATE r%, c%: PRINT MID$(ofile$(f%), spp%, 40)
      COLOR , 5: LOCATE r%, c% + (cpc% - 1): PRINT MID$(ofile$(f%), P%, 1)
      COLOR , 0
  END SELECT
  'LOCATE 10, 5: PRINT (LTRIM$(RTRIM$(STR$(p%)))) + SPACE$(2)
LOOP

EXIT SUB

InitVars:
  'ofile$(1) = SPACE$(100)
  'ofile$(2) = SPACE$(100)
  ovr$ = "OFF"     'overscore (insert)
  sourceasm$ = "Source Assembly file: "
  desbas$ = "Destination QBasic file: "
  L%(1) = LEN(sourceasm$) + 1
  L%(2) = LEN(desbas$) + 1
  f% = 1:          'file
  r% = 3:          'row
  c% = L%(1)       'column
  P% = 1:          'string positon
  spp% = 1         'string print position
  pr% = 1:         'print row
  pc% = 1:         'print column
  cpc% = 1         'current print column'
  ss% = 40:        'scroll span     
  s% = ASC("a")
RETURN
' FOR p2% = 1 TO 100
'   MID$(ofile$(1), p2%, 1) = CHR$(s%)
'   MID$(ofile$(2), p2%, 1) = CHR$(s%)
'   l$ = CHR$(s%)
'   s% = s% + 1
'   IF s% = ASC("z") + 1 THEN s% = ASC("a")
' NEXT p2%
RETURN

EXIT SUB

Initlocvars:
  up$ = CHR$(0) + CHR$(72)
  down$ = CHR$(0) + CHR$(80)
  lft$ = CHR$(0) + CHR$(75)
  rght$ = CHR$(0) + CHR$(77)
  insert$ = CHR$(0) + CHR$(82)
  esc$ = CHR$(27)
  bksp$ = CHR$(8)
  ent$ = CHR$(13)
  delete$ = CHR$(0) + CHR$(83)
  endk$ = CHR$(0) + CHR$(79)
  home$ = CHR$(0) + CHR$(71)
RETURN

colorchange:
  OUT &H3C8, &H0: OUT &H3C9, &H5: OUT &H3C9, &H5: OUT &H3C9, &H20
  OUT &H3C8, &H7: OUT &H3C9, &H38: OUT &H3C9, &H30: OUT &H3C9, &H0
  OUT &H3C8, &H5: OUT &H3C9, &H15: OUT &H3C9, &H15: OUT &H3C9, &H3F
  OUT &H3C8, &H3: OUT &H3C9, &H35: OUT &H3C9, &H35: OUT &H3C9, &H35
  OUT &H3C8, &H1: OUT &H3C9, &H5: OUT &H3C9, &H5: OUT &H3C9, &H5
RETURN
skip:

  CLS
  SCREEN 0: WIDTH 80, 50
  OUT &H3C8, &H5: OUT &H3C9, &H10: OUT &H3C9, &H10: OUT &H3C9, &H3F
  COLOR , 5
  LOCATE 5, 1: PRINT " "
  DO
    i$ = INKEY$
    IF i$ <> oi$ THEN LOCATE 5, 1: PRINT SPACE$(10)
    LOCATE 5, 1
    FOR c% = 1 TO LEN(i$)
      PRINT ASC(MID$(i$, c%, 1));
    NEXT c%
    IF i$ = CHR$(27) THEN EXIT DO
  LOOP
  COLOR , 0

END SUB

SUB Loadprefs
  Ldprf$ = "C:\abc2\qasmprf.pre"
  
  OPEN Ldprf$ FOR INPUT AS #1
  
  IF EOF(1) THEN GOTO exitsub
  LINE INPUT #1, ofile$(1)
  IF EOF(1) THEN GOTO exitsub
  LINE INPUT #1, ofile$(2)
exitsub:
  CLOSE
  OPEN Ldprf$ FOR OUTPUT AS #1

END SUB

SUB LoadRef (file$)
  q$ = CHR$(34)
  ref% = 1
  src% = 2
  des% = 3
  saf$ = LTRIM$(RTRIM$(ofile$(1)))
  dbf$ = LTRIM$(RTRIM$(ofile$(2)))
  CLOSE
  OPEN file$ FOR INPUT AS #1
  OPEN saf$ FOR INPUT AS #2
  SELECT CASE opendestfor$
    CASE "APPEND"
      OPEN dbf$ FOR APPEND AS #3
    CASE "OUTPUT"
      OPEN dbf$ FOR APPEND AS #3
      CLS : LOCATE 1, 1: PRINT "The file " + dbf$ + " is " + LTRIM$(RTRIM$(STR$(LOF(3)))) + " bytes."
      LOCATE 2, 1: PRINT "Are you sure you want to overwrite this file? (Y/N)"
      DO
        i3$ = INKEY$
        SELECT CASE i3$
          CASE "Y", "y"
            CLOSE #3
            OPEN dbf$ FOR OUTPUT AS #3
            EXIT DO
          CASE "N", "n"
            EXIT DO
        END SELECT
      LOOP
  END SELECT
  CLS
  PRINT "<<< Writing to " + dbf$ + " >>>"
  PRINT ""
  PRINT #des%, "asm$ = " + q$ + q$
  PRINT "asm$ = " + q$ + q$
  DO UNTIL EOF(2)
    SEEK #ref%, 1
    LINE INPUT #2, s$
    s$ = " " + LTRIM$(RTRIM$(s$)) + " "
    asmstr$ = ASMSM$(s$)
    DO UNTIL EOF(ref%)
      LINE INPUT #ref%, r$
      IF INSTR(1, r$, asmstr$) <> 0 THEN
        mach$ = MID$(LTRIM$(r$), 1, 4)
        EXIT DO
      END IF
    LOOP
    mach1$ = MID$(mach$, 1, 2)
    mach2$ = MID$(mach$, 3, 2)
    IF mach2$ = "  " THEN
      PRINT #des%, "asm$ = CHR$(&H" + mach1$ + ")                 '" + asmstr$
      PRINT "asm$ = " + "CHR$(&H" + mach1$ + ")                 '" + asmstr$
    ELSE
      PRINT #des%, "asm$ = CHR$(&H" + mach1$ + ")" + " + CHR(&H" + mach2$ + ")" + "     '" + asmstr$
      PRINT "asm$ = CHR$(&H" + mach1$ + ")" + " + CHR(&H" + mach2$ + ")" + "     '" + asmstr$
    END IF
  LOOP
  PRINT ""
END SUB

SUB RegInit
   reg$(1) = "AX":  reg$(1) = "CX":  reg$(1) = "DX":  reg$(1) = "BX"
   reg$(5) = "AL":  reg$(6) = "CL":  reg$(7) = "DL":  reg$(8) = "BL"
   reg$(9) = "AH": reg$(10) = "CH": reg$(11) = "DH": reg$(12) = "BH"
  reg$(13) = "SP": reg$(14) = "BP": reg$(15) = "SI": reg$(16) = "DI"
END SUB

FUNCTION REGSTR% (P%, s$)
  REDIM is$(1 TO 3)
  REDIM i%(1 TO 3)
' GOSUB RegInit
  cnt% = 0
  FOR r% = 1 TO 16
    isn% = INSTR(P%, s$, reg$(r%))
    SELECT CASE isn%
      CASE IS <> 0
        cnt% = cnt% + 1
        i%(cnt%) = isn%
        is$(cnt%) = reg$(r%)
    END SELECT
  NEXT r%
  SELECT CASE cnt%
    CASE 0
      rs% = 0
    CASE 1
      rs% = i%(1)
    CASE 2
      IF i%(2) < i%(1) THEN SWAP i%(1), i%(2)
      rs% = i%(1)
    CASE 3
      REDIM ci%(1 TO 3)
      IF i%(1) = 0 THEN ci%(1) = 200 ELSE ci%(1) = i%(subs1%)
      IF i%(2) = 0 THEN ci%(2) = 200 ELSE ci%(2) = i%(subs2%)
      IF i%(3) = 0 THEN ci%(3) = 200 ELSE ci%(3) = i%(subs2%)
      FOR subs1% = 1 TO 2: FOR subs2% = subs% + 1 TO 3
        IF ci%(subs2%) < ci%(subs1%) THEN SWAP i%(subs2%), i%(subs1%)
      NEXT subs2%, subs1%
      rs% = i%(1)
  END SELECT
  REGSTR% = rs%
EXIT FUNCTION

END FUNCTION

